Subject: bug#51458: closed (Re: bug#51458: grep PCRE - '^' and '$' are not recognized as begin and end of line for multiline strings)

From: [email-masked] (GNU bug Tracking System)
Date: Tue, 09 Nov 2021 18:06:02 +0000

Your bug report

#51458: grep PCRE - mean

which was filed against the grep package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
51458: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=51458
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#51458: grep PCRE - '^' and '$' are not recognized as begin and end of line for multiline strings
From: Paul Eggert <[email-masked]>
To: "Skrzyniarz, Slawomir (Nokia - PL/Krakow)" <[email-masked]>, "[email-masked]" <[email-masked]>
Date: Tue, 9 Nov 2021 10:05:31 -0800
List-Id: <debbugs-submit.debbugs.gnu.org>

On 11/8/21 22:48, Skrzyniarz, Slawomir (Nokia - PL/Krakow) wrote:
> Solve my issue.

Thanks for letting us know; closing the bug report.

Subject: grep PCRE - mean
From: "Skrzyniarz, Slawomir (Nokia - PL/Krakow)" <[email-masked]>
To: "[email-masked]" <[email-masked]>
Date: Thu, 28 Oct 2021 08:23:08 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello Grep Team,
I would update grep from version 2.20 to 3.1 and noticed that grep with -P option
stops recognize below regular expression:

cat SomeTestFile.cpp | sed -r -e 's:\/(\*([^*]|\*[^\/])*[*]\/|\/.*)::g' -e 's:\"[^"]*\"::g' |
grep -ozPLq '\A(?:\s*^(?:#\w+.*\s*|extern\s+.+)$)*+(?<namespace>\s*namespace(?:\s+ utTestNamespace \s*(?>(?<block>{(?:[^{}]*(?&block)*)*}))|(\s*[\w:]*\s*{)(?&namespace)\s*}))\s*\z'; echo "retcode $?"

Content of file SomeTestFile.cpp:
#include <memory>
#include <vector>
#include <gtest/gtest.h>

namespace utTestNamespace
{
using ::testing::NiceMock;
# some code here
}
//end of file

I checked regular expression on regex101.com webpage and noticed that mentioned regex is working for PCRE and PCRE2 on webpage but stop working in grep 3.1 and later versions (versions between 2.20 and 3.1 were not checked).
See link:
https://regex101.com/r/9NwluI/1/

Investigation shows that grep in 3.1 version and later 3.6 and 3.7 different handle "^" and "$" for "-P" option.
It looks that "^" does not detect all begin of lines but "$" does not recognize all end of lines.

It seems that "^" is treated as beginning of whole test string - not new lines.
"$" is suspected to recognize only end of whole test string - not end of lines.

I would ask you if is intended behavior or it looks like an issue in grep.

useful command in test:
cat SomeTestFile.cpp | sed -r -e 's:\/(\*([^*]|\*[^\/])*[*]\/|\/.*)::g' -e 's:\"[^"]*\"::g' | grep -zP '(?:\s*^(?:\#\w+.*\s*|extern\s+.+)$)*+'
cat SomeTestFile.cpp | sed -r -e 's:\/(\*([^*]|\*[^\/])*[*]\/|\/.*)::g' -e 's:\"[^"]*\"::g' | grep -zP '(?:\s*^(?:\#\w+.*\s*|extern\s+.+)\s*)*+'

Best Regards,
Sławek